%{
#include "rotfl.h"
#include "y.tab.h"
%}

IDENTFIRSTCHAR	[a-zA-Z_*~=]
IDENTCHAR	[a-zA-Z0-9_*~=/-]
IDENTLASTCHAR	[a-zA-Z0-9_*~=]

%%

[ \t\r\n]+	/* Eat up whitespace */

"#"[^\n]*\n	/* Eat up comments */

{IDENTFIRSTCHAR}{IDENTCHAR}*{IDENTLASTCHAR} yylval.ident = hash (yytext); return TOK_IDENT;
{IDENTFIRSTCHAR} yylval.ident = hash (yytext); return TOK_IDENT;

"("		return TOK_LPAREN;

")"		return TOK_RPAREN;

";"		return TOK_SEMICOLON;

">"		return TOK_ARROW;

.		error ("invalid character");
